<template>
    <div class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-12">
                    <h1 class="m-0 mb-4">Product</h1>

                    <div 
                        v-if="messageShow"
                        class="alert w-25 alert" 
                        :class="messageType"
                        role="alert"
                    >
                       {{ message }}
                    </div>
                </div>

                <div class="col-sm-12">
                    <div class="card">
                        <div class="card-body">

                            <div class="input-group mb-3 w-25">
                                <input 
                                    type="text" 
                                    class="form-control" 
                                    aria-label="Text input with dropdown button"
                                    v-model="search"
                                    @change="getProducts(currentPage)"
                                >
                                
                                <select 
                                    class="form-control" 
                                    id="inputGroupSelect03"
                                    v-model="filter"
                                    @change="getProducts(currentPage)"
                                >
                                    <option value="Food" selected>Food</option>
                                    <option value="Car">Car</option>
                                    <option value="Candy">Candy</option>
                                    <option value="Computer">Computer</option>
                                    <option value="Motor">Motor</option>
                                </select>

                                
                            </div>

                            <a href="/products/create" class="btn btn-primary create-product">Create</a>

                            <table class="table table-bordered mb-5">
                                <thead>
                                    <tr>
                                        <th style="width: 10px;">#</th>
                                        <th>Name</th>
                                        <th>Category</th>
                                        <th>Date and Time</th>
                                        <th class="w-50">Description</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="(product, index) in products" :key="index">
                                        <td>{{ product.id }}</td>
                                        <td>{{ product.name }}</td>
                                        <td>{{ product.category }}</td>
                                        <td>{{ product.date_time }}</td>
                                        <td>{{ product.description }}</td>
                                        <td>
                                            <button type="button" class="btn btn-danger btn-sm" @click="remove(product.id)">DELETE</button>
                                            <a :href="'/products/' + product.id" class="btn btn-warning btn-sm ml-3">UPDATE</a>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>

                            <pagination 
                                v-if="products.length > 0" 
                                :pagination="pagination"
                                @next-page="getProducts"
                            ></pagination>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import pagination from '../components/pagination.vue';

export default {
    components: {
        pagination
    },
    data() {
        return {
            products: {},
            pagination: {},
            search: '',
            filter: '',
            currentPage: 1,
            message: '',
            messageType: '',
            messageShow: false
        }
    },
    mounted() {
        this.getProducts(1);
    },
    methods: {
        getProducts(page) {
            this.currentPage = page
            axios.post('/api/productsList?page=' + this.currentPage, {
                params: {
                    search: this.search,
                    filter: this.filter
                }
            })
            .then((response) => {
                this.products = response.data.data
                this.pagination = response.data
            })
        },
        remove(id) {
            axios.delete(`/api/products/${id}`)
            .then(() => {
                this.message = 'Product is Deleted!';
                this.messageType = 'alert-danger';
                this.messageShow = true;
                this.getProducts(this.currentPage)

                setTimeout(() => {
                    this.messageShow = false
                }, 2000);
            })
        }
    },
};
</script>

<style scoped>
.create-product {
    position: absolute;
    top: 1rem;
    right: 1.5rem;
}
.alert {
    position: absolute;
    top: 0;
    right: 10px;
}
</style>
